package com.liang.service;

import com.liang.entity.BaseCompany;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * (BaseCompany)表服务接口
 *
 * @author makejava
 * @since 2023-02-15 23:13:18
 */
public interface BaseCompanyService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseCompany queryById(Integer id);

    /**
     * 分页查询
     *
     * @param baseCompany 筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<BaseCompany> queryByPage(BaseCompany baseCompany, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param baseCompany 实例对象
     * @return 实例对象
     */
    int insert(BaseCompany baseCompany);

    /**
     * 修改数据
     *
     * @param baseCompany 实例对象
     * @return 实例对象
     */
    int update(BaseCompany baseCompany);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 分页查询
     *
     * @param map
     * @return
     */
    List<BaseCompany> getBaseCompanyList(Map map);

    /**
     * 新建单位
     *
     * @param baseCompany
     * @return
     */
    int doAdd(BaseCompany baseCompany);

    /**
     * 校验单位全称是否唯一
     *
     * @param dwqc
     * @return
     */
    int checkCompanyUnique(String dwqc);

    /**
     * 批量删除
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);
}
